import buildinfo.BuildInfo
import scopt.OParser
import java.io.File

case class Config(
  file: File = null
)

object Config {

  def parse(args: Array[String]): Option[Config] =
    OParser.parse(options, args, Config())

  private val builder = OParser.builder[Config]
  private val options = {
    import builder._

    OParser.sequence(
      programName("labs06"),
      head("labs06", BuildInfo.version),
      help("help").text("Print help"),
      arg[File]("<file>")
        .required()
        .action((x, c) => c.copy(file = x))
        .text("one file argument"),
      checkConfig {
        case c if c.file == null => failure(s"File was not specified")
        case c if !c.file.exists => failure(s"File not found: ${c.file}")
        case _ => success
      }
    )
  }
}
