import scallion.input.Positioner

sealed abstract class Position
case object NoPosition extends Position {
  override def toString = "?:?"
}
case class Point(line: Int, column: Int) extends Position {
  override def toString = s"$line:$column"
}

case class Range(p1: Point, p2: Point)

object LinePositioner extends Positioner[Char, Position] {
  override val start: Position = Point(1, 1)
  override def increment(pos: Position, chr: Char): Position = pos match {
    case NoPosition => NoPosition
    case Point(l, c) =>
      if (chr == '\n') Point(l + 1, 1)
      else Point(l, c + 1)
  }
}
